<?php
/**
*  Postcot 1
*
*  Copyright notice
*  (c) 2012-2015 Marco Moser <marco@marcomoser.it>
*  All rights reserved
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
*
*  @copyright	Copyright (c) 2012-2015, Marco Moser
*  @author      Marco Moser <marco@marcomoser.it>
*  @version 	postcot 1.0.0 20/12/2012
*  @version 	postcot 1.2.0 5/5/15
*  @license	GNU General Public License version 2 or later
*  @see 	http://www.marcomoser.it
*/


define('POSTCOT_VERSION','postcot 1.2.0 GPL');
define('POSTCOT_PASSWORD_ISSET','********');

require_once 'pc-config.inc.php';


//////////////////////////////
// connect to db

$my_cfg=array();

try { dbInit(); }
catch(Exception $exc) { print $exc; output_postcot_help($my_cfg); exit; }


//////////////////////////////
// user login and profile

session_start();

//todo separa login da profiling
$my_cfg=load_user_profile(); // load user and langs
$dmap=domain_map($my_cfg);


//////////////////////////////
// eval form

$mlist=array();
if (!$my_cfg)
{
    //nop
}
else if (isset($_REQUEST['btn_login']))
{
    if ($mlist=submit_login_gui($my_cfg));
    else
    {
    	$my_cfg=load_user_profile();
    	$dmap=domain_map($my_cfg);
    }
}
else if (isset($_REQUEST['btn_logout']))
{
    submit_logout_gui($my_cfg);
    $my_cfg=load_user_profile();
    $dmap=domain_map($my_cfg);
}
else if ($my_cfg['ulev']=='anonymous')
{
    //nop
}
else if (isset($_REQUEST['btn_chgpasswd_ok']))
{
    if ($mlist=submit_change_password($my_cfg)) $_REQUEST['btn_chgpasswd']='btn_chgpasswd';
    else $mlist[]=abc('OK password changed');
}
else if (isset($_REQUEST['btn_sieve_ok']))
{
    if ($mlist=submit_sieve($my_cfg)) $_REQUEST['btn_sieve']='btn_sieve';
    else $mlist[]=abc('OK sieve changed');
}
else if (isset($_REQUEST['btn_vacation_ok']))
{
    if ($mlist=submit_vacation($my_cfg)) $_REQUEST['btn_vacation']='btn_vacation';
    else $mlist[]=abc('OK vacation changed');
}
else if (isset($_REQUEST['btn_forwarding_y']) || isset($_REQUEST['btn_forwarding_n']))
{
    if ($mlist=submit_forwarding($my_cfg)) $_REQUEST['btn_forwarding']='btn_forwarding';
    else $mlist[]=abc('OK data changed');
}
else if (($my_cfg['ulev']=='super'||$my_cfg['ulev']=='admin') && isset($_REQUEST['btn_grid_apply']))
{
    $mlist=submit_address_grid($my_cfg);
    // potrei aver cambiato il mio profilo
    $my_cfg=load_user_profile();
    $dmap=domain_map($my_cfg);
    $_REQUEST['btn_grid']='btn_grid';
}
//todo xor localhost x jobs by cron + notifica x email
else if ($my_cfg['ulev']=='super' && isset($_REQUEST['btn_grid_usage']))
{
    if ($mlist=disk_usage($my_cfg));
    else $mlist[]=abc('OK data updated');
    $_REQUEST['btn_grid']='btn_grid';
}
else if (($my_cfg['ulev']=='super'||$my_cfg['ulev']=='admin') && isset($_REQUEST['btn_grid_csv']))
{
    print output_address_grid($my_cfg,$dmap,true);
    exit;
}





//////////////////////////////
// show grid



?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="<?=$my_cfg['ulang']?>" xml:lang="<?=$my_cfg['ulang']?>">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="generator" content="<?=POSTCOT_VERSION?>" />
<style type="text/css">
/*
* blue #336
* red #900
* grey #ccc
*/

body {
    margin: 0;
    padding: 0;
}
body, table {
    font-family: Arial;
    font-size: small;
}
body a, table a {
    text-decoration: none;
    color: #07b;
}
body a:hover, table a:hover {
    text-decoration: underline;
}

.topbar {
    background-color: #222;
    overflow: hidden;
}
.topbar a {
    padding: 0 15px;
    color: #eee;
}
.gridbar {
    background-color: #eee;
    overflow: hidden;
}



.formgui {
    text-align: center;
}
.tblgui {
    margin: 50px auto;
    padding: 20px;
    background-color: #eee;
    border-collapse: collapse;
    border-spacing: 0;
    border: 1px solid #ccc;
}
.tblgui th {
    background-color: #ddd;
}
.tblgui td,.tblgui th {
    padding: 10px;
}
.tblgrid {
    border-collapse: collapse;
    border-spacing: 0;
    width: 100%;
    border-top: 1px solid #ccc;
}
.div_az {
    border: 1px solid #ccc;
    background-color: #fff;
}
.div_az a {
    padding: 0 2px;
}
.div_az a.selected {
    color: #fff;
    background-color: #000;
}
.tblgrid th,.tblgrid td {
    margin: 0;
    padding: 1px 4px;
    vertical-align: top;
    border-bottom: 1px solid #ccc;
    border-right: 1px solid #ccc;
    white-space: nowrap;
}
.tblgrid input,textarea,select {
    font-family: Arial;
    font-size: small;
}
.warn {
    background-color: #ffc;
}
.tblgrid tr:hover {
    background-color: #eee;
}
.inpless {
    border-color: transparent;
}
.inpless:hover {
    border-color: #333;
}
.tdhe {
    background-color: #eee;
    white-space: nowrap;
}
.divmsg {
    border: 10px solid #fff;
    background-color: #ffc;
    padding: 10px;
}
.divgridhelp {
    margin: 20px;
}
.divhelp {
    margin: 20px;
}
.divhelp h3 {
    margin-top: 5em;
    margin-bottom: 2em;
    background-color: #ccc;
    padding: 5px;
}
.divhelp textarea {
    width: 90%;
    display: block;
}
.precmd {
    background-color: #333;
    color: #fff;
    font-size: medium;
    width: 90%;
}
</style>
<script type="text/javascript">
function postcot_chg(idx,selectnode)
{
    document.getElementById('_chg'+idx).value='Y';
    if (selectnode)
    {
    	if (selectnode.options[selectnode.selectedIndex].value=='del') document.getElementById('_tr'+idx).style.backgroundColor='#f99';
    	else document.getElementById('_tr'+idx).style.backgroundColor='transparent';
    }
}

function keying_pass(idx,inpid)
{
    var inp_node=document.getElementById(inpid);
    var inp_val=document.getElementById(inpid).value;
    var inp_ok=inp_val.match(/[0-9]/i) && inp_val.match(/[a-z]/i) && inp_val.match(/.{8,}/i);
    if (inp_ok) inp_node.style.borderColor='green';
    else inp_node.style.borderColor='red';
}



function make_password(idx,inpid)
{
    var alfa='abcdefghjklmnpqrstuvwxyz-.';
    var digit='23456789';
    var sym='!@#$%*+';
    var password='';
    for(var ii=0;ii<8;ii++)
    {
    	if (ii<1) password+=alfa.substr(Math.floor(Math.random()*(alfa.length-2)),1);
	else if (ii<5) password+=alfa.substr(Math.floor(Math.random()*alfa.length),1);
	else if (ii<7) password+=digit.substr(Math.floor(Math.random()*digit.length),1);
	else if (ii<8) password+=sym.substr(Math.floor(Math.random()*sym.length),1);
    }

    document.getElementById(inpid).value=password;
    document.getElementById('_chg'+idx).value='Y';
}
function toggleid(anode,id,onoff)
{
    if (onoff=='on')
    {
    	document.getElementById(id).style.display='';
    	anode.style.display='none';
    }
    else
    {
	document.getElementById(id).style.display='none';
	anode.style.display='none';
    }
}
function select_domain(selectnode,inpid)
{
    var out='';
    for(var ii=0;ii<selectnode.options.length;ii++)
    {
	if (selectnode.options[ii].selected) out+=","+selectnode.options[ii].value;
    }
    document.getElementById(inpid).value=out.substr(1); // skip ,
    return true;
}
function set_filter_orderby(oby)
{
    document.getElementById('filter_orderby').value=oby;
    document.getElementById('fpostcot').submit();
}
function set_filter_az(val)
{
    document.getElementById('filter_az').value=val;
    document.getElementById('fpostcot').submit();
}


</script>
</head>
<body>

<div style="height: 2em;">
<div class="topbar" style="position: fixed; line-height: 2em; width: 100%; z-index: 100; min-width: 590px;">
<div style="float: right;">
<a href="<?=POSTCOT_SUPPORT_URL?>"><?=abc('customer support')?></a>
<a href="http://www.marcomoser.it/postcot" target="_blank"><?=POSTCOT_VERSION?></a>
</div>

<? if ($my_cfg['ulev']=='anonymous') { ?>
&nbsp;
<? } else { ?>
<a href="<?=$my_cfg['postcot_url']?>?btn_home=btn_home"><?=abc('home')?></a>
<? if ($my_cfg['ulev']=='super'||$my_cfg['ulev']=='admin') { ?>
<a href="<?=$my_cfg['postcot_url']?>?btn_grid=btn_grid"><?=abc('email domains')?></a>
<? } ?>
<a href="<?=$my_cfg['postcot_url']?>?btn_logout=btn_logout"><?=abc('log off')?> <?=$my_cfg['pc_address']?></a>
<? } ?>
</div><!-- topbar -->
</div>


<?
if ($mlist)
{
    print '<div class="divmsg" style="position: fixed; width: 100%; z-index: 100;">'.implode(" | ",$mlist).'</div>';
    print '<div class="divmsg">'.implode(" | ",$mlist).'</div>'; // trick height
}
?>



<?
if ($my_cfg['ulev']=='anonymous') print output_login_gui($my_cfg);
else if (isset($_REQUEST['btn_help']))
{
    print '<div class="divhelp">';
    print output_postcot_help($my_cfg);
    print '</div>';
}
else if (isset($_REQUEST['btn_chgpasswd'])) print output_change_password($my_cfg);
else if (isset($_REQUEST['btn_forwarding'])) print output_forwarding_gui($my_cfg);
else if (isset($_REQUEST['btn_sieve'])) print output_sieve_gui($my_cfg);
else if (isset($_REQUEST['btn_vacation'])) print output_vacation_gui($my_cfg);
else if (isset($_REQUEST['btn_credits'])) print output_credits_gui($my_cfg);
else if (isset($_REQUEST['btn_grid'])) print output_address_grid($my_cfg,$dmap,false);
else output_user_welcome($my_cfg); // default home
?>

</body>
</html>
<?

////////////////////////////////////////////////////////////////////////////////


function output_address_grid(&$my_cfg,$dmap,$is_csv)
{
    $filter_orderby=@$_REQUEST['filter_orderby'];
    $filter_desc='';
    $filter_domain=@$_REQUEST['filter_domain'];
    if (!$filter_domain) $filter_domain=preg_replace(':.*@:','',$my_cfg['pc_address']); // default my domain
    $filter_az=@$_REQUEST['filter_az'];
    if (!$filter_az)
    {
    	// se ho tante caselle filtra a-z else *
    	if ($my_cfg['my_cntdom']>100) $filter_az='a';
    	else $filter_az='*';
    }

    $ww=array();
    if (@$val=$_REQUEST['filter_search'])
    {
	$val=strtolower(preg_replace(':[^\w@.-]+:','%',$val)); // security
	$ww[]=sprintf("(lower(pc_address) like '%%%s%%' or lower(pc_alias_csv) like '%%%s%%' or lower(pc_note) like '%%%s%%')",$val,$val,$val);
    }
    if (($val=$filter_domain) && $val!='*')
    {
	$val=preg_replace(':[^\w@.-]:','',$val); // security
	$ww[]=sprintf("(pc_domain='%s')",$val);
    }
    if (($val=$filter_az) && $val!='*')
    {
	$val=preg_replace(':[^\w@.-]:','',$val); // security
	$ww[]="lower(pc_address) like '$val%%'";
    }

    if (!$ww) $ww[]='1=1';
    $sql='select * from postcot_users where '.implode(' and ',$ww);

    if ($filter_orderby<0) { $filter_orderby=-$filter_orderby; $filter_desc=' desc'; }

    if (!$filter_orderby) $sql.=" order by pc_domain $filter_desc,pc_address $filter_desc";
    else if ($filter_orderby==1) $sql.=" order by pc_address $filter_desc,pc_domain $filter_desc";
    else if ($filter_orderby==2) $sql.=" order by pc_domain $filter_desc,pc_address $filter_desc";
    else if ($filter_orderby==3) $sql.=" order by pc_password $filter_desc";
    else if ($filter_orderby==4) $sql.=" order by pc_alias_csv $filter_desc";
    else if ($filter_orderby==5) $sql.=" order by pc_mgrdom_csv $filter_desc";
    else if ($filter_orderby==6) $sql.=" order by pc_diskusage_kb $filter_desc";
    else if ($filter_orderby==7) $sql.=" order by pc_note $filter_desc";
    else if ($filter_orderby==8) $sql.=" order by pc_mtime $filter_desc";

    $rs=selectPrepared($sql);

    ////////////////////
    // csv output

    if ($is_csv)
    {
    	$klist=array('pc_id','pc_address','pc_domain','pc_type','pc_alias_csv','pc_mgrdom_csv','pc_mgrdom_nr','pc_mgrquota_kb','pc_mgrusage_kb','pc_diskusage_kb','pc_diskquota_kb','pc_note','pc_maddr','pc_mtime');

    	header('Content-Type: text/csv');
    	header('Content-Disposition: attachment; filename=postcot.csv');
	$fp = fopen('php://output','w');

	fputcsv($fp,$klist,';');
	while($row=$rs->fetch())
	{
	    $olist=array();
	    foreach($klist as $kk) $olist[]=$row[$kk];
	    fputcsv($fp,$olist,';');
	}
	fclose($fp);
	return;
    }

    ////////////////////
    // html output

?>
<form id="fpostcot" action="<?=$my_cfg['postcot_url']?>" method="post" style="margin: 0; padding: 0;">
<input type="hidden" id="filter_orderby" name="filter_orderby" value="<?=$filter_orderby?>"/>
<input type="hidden" id="filter_az" name="filter_az" value="<?=$filter_az?>"/>
<input type="hidden" name="btn_grid" value="btn_grid"/>

<div style="height: 5em;">
<div class="gridbar" style="position: fixed; height: 5em; width: 100%; z-index: 100; min-width: 590px;">
    <div style="float: left; padding: 1%; height: 98%; border-right: 1px solid #ccc;">
	<button type="submit" name="btn_grid_apply" value="btn_grid_apply" style="font-size: 130%;"><?=abc('SAVE<br/>APPLY')?></button>
    </div>
    <div style="float: left; padding: 1%;">

	<div>
	<select name="filter_domain" onchange="this.form.submit()">
	<option value="*">*</option>
<?
    foreach($dmap as $val => $lab)
    {
    	$on=$val==$filter_domain?' selected="selected"':'';
    	printf('<option value="%s"%s>%s</option>',$val,$on,$lab);
    }
?>
	</select>

	<input type="text" name="filter_search" value="<?=htmlspecialchars(@$_REQUEST['filter_search'])?>" onchange="this.form.submit()" title="<?=abc('full text search')?>" size="10"/>
	<a href="javascript:void(0)" onclick="document.getElementById('fpostcot').submit()">&gt;</a>
	</div>

	<div class="div_az" style="margin-top: 1%;">
<?
	$azmap=array('*'=>'*');
	for($ii=ord('a');$ii<=ord('z');$ii++) $azmap[chr($ii)]=chr($ii);
	foreach($azmap as $val => $lab)
	{
	    $on=$val==$filter_az?' class="selected"':'';
	    printf('<a href="javascript:void(set_filter_az(\'%s\'))" %s>%s</a>',$val,$on,$lab);
	}
?>
	</div>


    </div>
    <div style="float: right; padding: 1%; height: 98%; border-left: 1px solid #ccc;">
	<? if (POSTCOT_DU_CMD && $my_cfg['ulev']=='super') { ?>
	<button type="submit" name="btn_grid_usage" value="btn_grid_usage"><?=abc('Update disk usage')?></button><br/>
	<? } ?>
	<button type="submit" name="btn_grid_csv" value="btn_grid_csv"><?=abc('Download (CSV)')?></button>
    </div>
</div><!-- gridbar -->
</div>

<table class="tblgrid">
<tr>
    <th class="tdhe"></th>
    <th class="tdhe"><div style="float: right;"><a href="javascript:void(set_filter_orderby(1))">&uarr;</a><a href="javascript:void(set_filter_orderby(-1))">&darr;</a></div><?=abc('email address')?></th>
    <th class="tdhe"><div style="float: right;"><a href="javascript:void(set_filter_orderby(2))">&uarr;</a><a href="javascript:void(set_filter_orderby(-2))">&darr;</a></div><?=abc('domain')?></th>
    <th class="tdhe"><div style="float: right;"><a href="javascript:void(set_filter_orderby(3))">&uarr;</a><a href="javascript:void(set_filter_orderby(-3))">&darr;</a></div><?=abc('password')?></th>
    <th class="tdhe"><div style="float: right;"><a href="javascript:void(set_filter_orderby(4))">&uarr;</a><a href="javascript:void(set_filter_orderby(-4))">&darr;</a></div><?=abc('forwards')?></th>
    <th class="tdhe"><div style="float: right;"><a href="javascript:void(set_filter_orderby(5))">&uarr;</a><a href="javascript:void(set_filter_orderby(-5))">&darr;</a></div><?=abc('admin')?></th>
    <th class="tdhe"><div style="float: right;"><a href="javascript:void(set_filter_orderby(6))">&uarr;</a><a href="javascript:void(set_filter_orderby(-6))">&darr;</a></div><?=abc('quota')?></th>
    <th class="tdhe"><div style="float: right;"><a href="javascript:void(set_filter_orderby(7))">&uarr;</a><a href="javascript:void(set_filter_orderby(-7))">&darr;</a></div><?=abc('note')?></th>
    <th class="tdhe"><div style="float: right;"><a href="javascript:void(set_filter_orderby(8))">&uarr;</a><a href="javascript:void(set_filter_orderby(-8))">&darr;</a></div><?=abc('action')?></th>
</tr>

<?

$eod=false;
$emptycc=$my_cfg['pc_mgrdom_nr']-$my_cfg['my_cntdom'];
if ($emptycc>POSTCOT_FREE_ROWS) $emptycc=POSTCOT_FREE_ROWS;
for($cc=0;true;$cc++)
{
    if (!$eod)
    {
    	if (!$row=$rs->fetch()) $eod=true;
    	else if (!preg_match($my_cfg['pc_mgrdom_reg'],$row['pc_domain'])) { $cc--; continue; }
    }
    if ($eod)
    {
    	if ($emptycc--<=0) break;
    	$row=array(
    	    'pc_type'=>'E',
    	    );
    }
    if (@$row['pc_password']) $row['pc_password']=POSTCOT_PASSWORD_ISSET;
    if (@$row['pc_alias_csv']) $alias_list=preg_split(':\s*,\s*:',$row['pc_alias_csv'],-1,PREG_SPLIT_NO_EMPTY); else $alias_list=array();
    $cnt_alias=count($alias_list);

    if (preg_match(':(.*)@(.*):u',@$row['pc_address'],$toks)) $pc_address_1=$toks[1];
    else $pc_address_1=@$row['pc_address'];
?>
<tr id="_tr<?=$cc?>">
    <td class="tdhe" style="text-align: right;">
    <?=@$row['pc_id']?$cc+1:''?> <input type="hidden" name="pc_id[]" value="<?=@$row['pc_id']?>" /><input type="hidden" id="_chg<?=$cc?>" name="_chg[]" value="N" />
    </td>
    <td>
    <input class="inpless" type="text" name="pc_address[]" value="<?=htmlspecialchars($pc_address_1)?>" size="17" onchange="postcot_chg(<?=$cc?>)" title="<?=abc('info | info@example2.it (create new domain) | @example.it (as entire domain alias)')?>" />
    </td>
    <td>
    <?if (@$row['pc_address']) print '<a href="mailto:'.htmlspecialchars($row['pc_address']).'">@</a>'; else print '@';?>
    <select style="border: 0;" onchange="postcot_chg(<?=$cc?>)" name="pc_domain[]" title="<?=abc('manual (create new domain)')?>">
<?
    $smap=array(''=>abc('(manual)'));
    $smap=array_merge($smap,$dmap);
    foreach($smap as $val => $lab)
    {
	$on=$val==$row['pc_domain']?' selected="selected"':'';
    	printf('<option value="%s"%s>%s</option>',$val,$on,$lab);
    }
?>
	</select>


    </td>
    <td>
	<input id="_pass<?=$cc?>" class="inpless" type="text" name="pc_password[]" value="<?=htmlspecialchars(@$row['pc_password'])?>" size="10" onchange="postcot_chg(<?=$cc?>)" onkeyup="keying_pass(<?=$cc?>,'_pass<?=$cc?>')" title="<?=abc('mandatory for all, 8+ chars')?>"/>
	<a href="javascript:void(make_password(<?=$cc?>,'_pass<?=$cc?>'))" title="<?=abc('generate password')?>">&lt;</a>
    </td>
    <td>
<?
	if ($cnt_alias>0) printf('<a href="javascript:void(0)" onclick="toggleid(this,\'_alias%d\',\'on\')">Y (%d)</a>',$cc,$cnt_alias);
	else printf('<a href="javascript:void(0)" onclick="toggleid(this,\'_alias%d\',\'on\')">n</a>',$cc);
	$nrows=($cnt_alias<3?3:($cnt_alias>10?10:$cnt_alias));
?>
	<div id="_alias<?=$cc?>" style="display: none;">
	<?=abc('email list')?>:</br>
	<textarea name="pc_alias_csv[]" cols="27" rows="<?=$nrows?>" onchange="postcot_chg(<?=$cc?>)" title="<?=abc('info@example.it me@example.it (one per line) | @example.it (as entire domain alias)')?>"><?=htmlspecialchars(implode("\n",$alias_list))?></textarea>
	</div>
    </td>

<?
    $tdattr='';
    $du='';
    if (@$row['pc_mgrusage_kb'])
    {
    	$du='['.quota_kb_str($row['pc_mgrusage_kb'],true).']';
    	if ($row['pc_mgrquota_kb']>0 && $row['pc_mgrusage_kb']/$row['pc_mgrquota_kb']>0.9) $tdattr='class="warn"';
    }
?>
    <td <?=$tdattr?>>
<?
    if (@$row['pc_mgrdom_csv']) printf('<a href="javascript:void(0)" onclick="toggleid(this,\'_mgr%d\',\'on\')">Y %s</a>',$cc,$du);
    else printf('<a href="javascript:void(0)" onclick="toggleid(this,\'_mgr%d\',\'on\')">n</a>',$cc);

?>
    <div id="_mgr<?=$cc?>" style="display: none;">
	<input id="_mgrdom<?=$cc?>" type="hidden" name="pc_mgrdom_csv[]" value="<?=htmlspecialchars(@$row['pc_mgrdom_csv'])?>" />
	<?=abc('managed domains')?>:<br/>
	<select multiple="multiple" onchange="select_domain(this,'_mgrdom<?=$cc?>'); postcot_chg(<?=$cc?>);" title="<?=abc('no selection (simple user) | * (superuser) | one or more (admin)')?>">
<?
    $smap=array('-'=>'- off');
    if ($my_cfg['ulev']=='super') $smap['*']='* superuser';
    $smap=array_merge($smap,$dmap);
    foreach($smap as $val => $lab)
    {
    	$on='';
    	if (@$row['pc_mgrdom_csv'])
    	{
    	    $reg='/,'.preg_quote($val).',/';
	    if ($val=='*' && $row['pc_mgrdom_csv']=='*') $on=' selected="selected"';
	    else if (preg_match($reg,','.$row['pc_mgrdom_csv'].',')) $on=' selected="selected"';
	}
	else if ($val=='-') $on=' selected="selected"';
    	printf('<option value="%s"%s>%s</option>',$val,$on,$lab);
    }
?>
	</select>
	<br/>
	<?=abc('nr of email limit &uarr;')?>:<br/>
	<input type="text" name="pc_mgrdom_nr[]" value="<?=intval(@$row['pc_mgrdom_nr'])?>" size="3" onchange="postcot_chg(<?=$cc?>)"/><br/>
	<?=abc('disk quota limit &uarr;')?>:<br/>
	<input type="text" name="pc_mgrquota_kb[]" value="<?=quota_kb_str(@$row['pc_mgrquota_kb'],false)?>" size="3" onchange="postcot_chg(<?=$cc?>)" title="<?=abc('null (no disk limit) | 90M (90 megabyte) | 10G (gigabtyte)')?>"/>
	<?=$du?>
	<br/>
	<? if ($my_cfg['ulev']!='super') print '<div>(* '.abc('only superuser can change').')</div>'; ?>
	</div>
    </td>

<?
    $tdattr='';
    $du='';
    if (@$row['pc_diskusage_kb'])
    {
    	$du='['.quota_kb_str($row['pc_diskusage_kb'],true).']';
    	if ($row['pc_diskquota_kb']>0 && $row['pc_diskusage_kb']/$row['pc_diskquota_kb']>0.9) $tdattr='class="warn"';
    }
?>
    <td <?=$tdattr?>>
	<input class="inpless" type="text" name="pc_diskquota_kb[]" value="<?=quota_kb_str(@$row['pc_diskquota_kb'],false)?>" size="5" onchange="postcot_chg(<?=$cc?>)" title="<?=abc('null (no disk limit) | 90M (90 megabyte) | 10G (gigabtyte)')?>" />
	<?=$du?>
    </td>
    <td>
	<textarea class="inpless" style="width: 100%;" name="pc_note[]" cols="27" rows="1" onchange="postcot_chg(<?=$cc?>)" onclick="this.attributes['rows'].value=3"><?=htmlspecialchars(@$row['pc_note'])?></textarea>
    </td>
    <td>
    <select style="border: 0;" name="_op[]" onchange="postcot_chg(<?=$cc?>,this)">
    <option value="on"><?=abc('on')?></option>
    <option value="off" <?=@$row['pc_type']=='N'?'selected="selected"':''?>><?=abc('off')?></option>
    <option value="del"><?=abc('del')?></option>
    </select>
    <? if (@$row['pc_mtime']) printf('<span style="font-size: x-small;" title="%s %s">%s</span>',$row['pc_maddr'],$row['pc_mtime'],timestamp_today($row['pc_mtime'])); ?>
    </td>
</tr>
<?
}
?>

</table>
</form>
<?
    if (abc('GRID_HELP')) print '<div class="divgridhelp">'.abc('GRID_HELP').'</div>';
    return '';
}


function submit_address_grid(&$my_cfg)
{
    $mlist=array();
    $down_insert=$my_cfg['pc_mgrdom_nr']-$my_cfg['my_cntdom'];
    for($ii=0;$ii<count($_REQUEST['_chg']);$ii++)
    {
    	if ($_REQUEST['_chg'][$ii]!='Y') continue; // not changed

    	$alist=preg_split(':\s*\n\s*:',trim($_REQUEST['pc_alias_csv'][$ii]),-1,PREG_SPLIT_NO_EMPTY);
    	usort($alist,'strcasecmp');
    	$row=array(
	    'pc_id' => intval($_REQUEST['pc_id'][$ii]),
	    'pc_address' => strtolower(trim($_REQUEST['pc_address'][$ii])),
	    'pc_domain' => strtolower(trim($_REQUEST['pc_domain'][$ii])),
	    'pc_alias_csv' => strtolower(implode(',',$alist)), // if exists
	    'pc_diskquota_kb' => quota_str_kb($_REQUEST['pc_diskquota_kb'][$ii]),
	    'pc_note' => $_REQUEST['pc_note'][$ii],
    	    );

	// only superuser can change
	if ($my_cfg['ulev']=='super')
	{
	    $row['pc_mgrdom_csv']=strtolower(trim($_REQUEST['pc_mgrdom_csv'][$ii]));
	    if (strpos(','.$row['pc_mgrdom_csv'].',',',-,')!==false) $row['pc_mgrdom_csv']=null;
	    else if (strpos(','.$row['pc_mgrdom_csv'].',',',*,')!==false) $row['pc_mgrdom_csv']='*';
	    $row['pc_mgrdom_nr']=intval($_REQUEST['pc_mgrdom_nr'][$ii]);
	    $row['pc_mgrquota_kb']=quota_str_kb($_REQUEST['pc_mgrquota_kb'][$ii]);
	}

    	if ($row['pc_domain'])
    	{
    	    $row['pc_address'].='@'.$row['pc_domain'];
    	    $row['pc_domain']=null;
    	}

    	if ($_REQUEST['_op'][$ii]=='off') $row['pc_type']='N';
    	else if ($row['pc_alias_csv']) $row['pc_type']='L';
    	else $row['pc_type']='E';

    	$clear_pass=trim(@$_REQUEST['pc_password'][$ii]);
    	if ($clear_pass==POSTCOT_PASSWORD_ISSET);
    	else
    	{
    	    if ($msg=validate_password_msg($clear_pass,$row['pc_address'])) { $mlist[]=$row['pc_address'].': '.$msg; continue; }
	    $row['pc_password']=md5($clear_pass); // schema=md5
    	}

    	switch($_REQUEST['_op'][$ii])
    	{
    	case 'on':
    	case 'off':

	    //email ok for: ! # $ % & ' * + - / = ? ^ _ ` { | } ~ e utf8 ?!?
	    // todo RFC 5322 RFC 5321 RFC 822 email syntax rfc
	    if (preg_match('/[^\w@._-]/',$row['pc_address']))
		{ $mlist[]='BAD char '.$row['pc_address']; continue; }

	    // address potrebbe essere vuoto x virtual domain
	    if (preg_match(':(.*)@(.+):',$row['pc_address'],$toks)) $row['pc_domain']=$toks[2];
	    else { $mlist[]='BAD format '.$row['pc_address']; continue; }

	    if (!preg_match($my_cfg['pc_mgrdom_reg'],$row['pc_domain']))
		{ $mlist[]='BAD domain '.$row['pc_address']; continue; }

	    if ($row['pc_id']) $mlist[]=update_row($my_cfg,$row);
	    else if ($down_insert--<=0) { $mlist[]='domain limit exceed for '.$row['pc_address']; continue; }
	    else $mlist[]=insert_row($my_cfg,$row);
    	    break;
    	case 'del':
    	    if ($row['pc_id']) $mlist[]=delete_row($my_cfg,$row);
    	    break;
    	}
    }
    return $mlist;
}


// @return null ok xor bad msg
function validate_password_msg($clear_pass,$not_equals)
{
    if (strcasecmp($clear_pass,$not_equals)==0) return 'BAD password (weak)';
    if (!preg_match(':.{8,}:ui',$clear_pass)) return 'BAD password (min 8 chars)';
    if (!preg_match(':[a-z]:ui',$clear_pass) || !preg_match(':[0-9]:ui',$clear_pass)) return 'BAD password (use alfa and digit)';
    return null;
}



function load_user_profile()
{
    $my_cfg=array(
    	'ulev'=>'anonymous',
	'pc_address'=>null,
	'pc_mgrdom_reg'=>'/^!$/',
	'pc_mgrdom_nr'=>null
	);
    if (@$_SESSION['postcot_user_address'])
    {
	$rs=selectPrepared('select * from postcot_users where pc_address=?',array($_SESSION['postcot_user_address']));
	while($urow=$rs->fetch())
	{
	    $my_cfg['pc_address']=$urow['pc_address'];
	    $my_cfg['pc_mgrdom_nr']=$urow['pc_mgrdom_nr'];
	    if ($urow['pc_mgrdom_csv']=='*')
	    {
		$my_cfg['ulev']='super';
		$my_cfg['pc_mgrdom_reg']='/.*/';
	    }
	    else if ($urow['pc_mgrdom_csv'])
	    {
		$my_cfg['ulev']='admin';
		$list=preg_split(':\s*,\s*:',$urow['pc_mgrdom_csv'],-1,PREG_SPLIT_NO_EMPTY);
		$my_cfg['pc_mgrdom_reg']='/^('.implode('|',$list).')$/i'; //todo preg_quote
	    }
	    else
	    {
		$my_cfg['ulev']='user';
	    }
	    load_system_parameters($my_cfg);
	    return $my_cfg;
	}
    }
    load_system_parameters($my_cfg);
    return $my_cfg;
}

function load_system_parameters(&$my_cfg)
{
    //myself
    $my_cfg['postcot_url']=preg_replace(':[?].*:','',$_SERVER['REQUEST_URI']);

    // lang
    $ulang='en';
    if (preg_match(':^(\w\w):',$_SERVER['HTTP_ACCEPT_LANGUAGE'],$toks))
    {
    	$ulang=$toks[1];
    	if (!file_exists("pc-lang-$ulang.inc.php")) $ulang='en';
    }
    $my_cfg['ulang']=$ulang;
    require_once "pc-lang-$ulang.inc.php"; // pc-lang-en.inc.php
}



function domain_map(&$my_cfg)
{
    $dmap=array();
    $rs=selectPrepared('select pc_domain,count(*) as cnt from postcot_users group by pc_domain order by pc_domain');
    $my_cntdom=0;
    while($row=$rs->fetch())
    {
    	if (!preg_match($my_cfg['pc_mgrdom_reg'],$row['pc_domain'])) continue;
    	$dmap[$row['pc_domain']]=sprintf('%s (%d)',$row['pc_domain'],$row['cnt']);
    	$my_cntdom+=$row['cnt'];
    }
    $my_cfg['my_cntdom']=$my_cntdom; // numero di domini gestiti
    return $dmap;
}

function disk_usage(&$my_cfg)
{
    $mlist=array();

    update_where('update postcot_users set pc_diskusage_kb=0,pc_mgrusage_kb=0');

    //////////////////////////
    // user quota

    $rs=selectPrepared('select * from postcot_users order by pc_domain,pc_address');
    while($urow=$rs->fetch())
    {
    	if (!preg_match(':(.+)@(.+):',$urow['pc_address'],$toks)) continue;
    	$urow['pc_address_1']=$toks[1];
    	$du=POSTCOT_DU_CMD;
    	$du=preg_replace(':\{pc_domain\}:',$urow['pc_domain'],$du);
    	$du=preg_replace(':\{pc_address\}:',$urow['pc_address'],$du);
    	$du=preg_replace(':\{pc_address_1\}:',$urow['pc_address_1'],$du);

    	set_time_limit(20); // avoid timeout

	if (!$ph=popen($du,'r'))
	{
	    $mlist[]=sprintf(abc('FAIL diskusage command %s'),$du);
	    continue;
	}
	$dukb=-1;
	while(($aa=fgets($ph))!==false)
	{
	    if (!preg_match(':^(\d+):',$aa,$toks)) continue;
	    $dukb=intval($toks[1]);
	}
	fclose($ph);
	if ($dukb<0)
	{
	    //new user
	    continue;
	}

	if (!update_where('update postcot_users set pc_diskusage_kb=? where pc_id=?',array($dukb,$urow['pc_id'])))
	{
	    $mlist[]=abc('FAIL on database diskusage update');
	    continue;
	}
    }


    //////////////////////////
    // sum quota

    $rs=selectPrepared('select pc_domain,sum(pc_diskusage_kb) as dusum from postcot_users group by pc_domain order by pc_domain');
    $dumap=array();
    while($row=$rs->fetch())
    {
    	$dumap[$row['pc_domain']]=$row['dusum'];
    }


    //////////////////////////
    // mgr quota

    $rs=selectPrepared('select * from postcot_users where pc_mgrdom_csv like \'_%\' order by pc_domain,pc_address');
    while($urow=$rs->fetch())
    {
    	$sumkb=0;
    	foreach($dumap as $dom => $dukb)
    	{
    	    $reg='/,'.preg_quote($dom).',/';
    	    if ($urow['pc_mgrdom_csv']=='*' || preg_match($reg,','.$urow['pc_mgrdom_csv'].',')) $sumkb+=$dukb;
    	}
	if (!update_where('update postcot_users set pc_mgrusage_kb=? where pc_id=?',array($sumkb,$urow['pc_id'])))
	{
	    $mlist[]=abc('FAIL on database mgr diskusage update');
	    continue;
	}
    }
    return $mlist;
}



////////////////////////////////////////////////////////////////////////////////



// oggetto $Pdo condiviso da tutta la sessione http (xke costoso)
global $Pdo;
function dbInit()
{
    global $Pdo;
    $Pdo=new PDO(POSTCOT_DBDSN, POSTCOT_DBUSER, POSTCOT_DBPASSWD,array(PDO::ATTR_DEFAULT_FETCH_MODE => PDO::FETCH_ASSOC,PDO::ATTR_CASE => PDO::CASE_LOWER));
}
function selectPrepared($sql,$params=null)
{
    global $Log,$Pdo;
    $rs=$Pdo->prepare($sql,array(PDO::CURSOR_FWDONLY)); // xor exception
    if (!$rs || ! $rs->execute($params))
    {
    	$perr=$Pdo->errorInfo();
    	print "Exception ".$perr[2]." sql=$sql\n";
    	exit;
    	//throw new Exception($perr[2]." sql=$sql");
    }
    return $rs;
}
function select_my_row(&$my_cfg)
{
    $rs=selectPrepared('select * from postcot_users where pc_address=?',array($my_cfg['pc_address']));
    return $rs->fetch(); // or null
}
function insert_row($my_cfg,$row)
{
    global $Pdo;
    $clist=array();
    $qlist=array();
    $vlist=array();
    foreach($row as $col=>$val)
    {
    	if ($col=='pc_id') continue;
    	$clist[]=$col;
    	$qlist[]='?';
    	$vlist[]=$val;
    }
    $clist[]='pc_maddr';
    $qlist[]='?';
    $vlist[]=$my_cfg['pc_address'];
    $sql='insert into postcot_users('.implode(',',$clist).',pc_mtime) values('.implode(',',$qlist).',current_timestamp)';

    if (!update_where($sql,$vlist)) return abc('DB FAIL').' '.$row['pc_address'];
    return abc('DB insert').' '.$row['pc_address'];
}

function update_row($my_cfg,$row)
{
    global $Pdo;
    $clist=array();
    $vlist=array();
    foreach($row as $col=>$val)
    {
    	if ($col=='pc_id') continue;
    	$clist[]="$col=?";
    	$vlist[]=$val;
    }
    $clist[]="pc_maddr=?";
    $vlist[]=$my_cfg['pc_address'];
    $vlist[]=$row['pc_id'];

    $sql='update postcot_users set '.implode(',',$clist).',pc_mtime=current_timestamp where pc_id=?';
    if (!update_where($sql,$vlist)) return abc('DB FAIL').' '.$row['pc_address'];
    return abc('DB update').' '.$row['pc_address'];
}
function update_where($sql,$vlist=null)
{
    global $Pdo;

    //print "@@ $sql ++ ".var_export($vlist,true);
    if ($Pdo->prepare($sql)->execute($vlist)) return true;
    return false;
}

function delete_row($my_cfg,$row)
{
    global $Pdo;
    $sql="delete from postcot_users where pc_id=?";
    $vlist=array();
    $vlist[]=$row['pc_id'];

    if (!update_where($sql,$vlist)) return abc('DB FAIL').' '.$row['pc_address'];
    return abc('DB delete').' '.$row['pc_address'];
}

function quota_kb_str($kb,$is_out=false)
{
    $sb='';
    if ($kb<=0) $sb='';
    else if ($is_out)
    {
	if ($kb>=1024*1024) $sb=sprintf('%0.1fG',$kb/1024/1024);
	if ($kb>=1024) $sb=sprintf('%0.1fM',$kb/1024);
	else $sb=sprintf('%dK',$kb);
    }
    else
    {
	if (($kb%(1024*1024))==0) $sb=sprintf('%dG',$kb/1024/1024);
	else if (($kb%1024)==0) $sb=sprintf('%dM',$kb/1024);
	else $sb=sprintf('%dK',$kb);
    }
    return $sb;
}
function quota_str_kb($str)
{
    if (preg_match(':(\d+)G:i',$str,$toks)) return $toks[1]*1024*1024;
    if (preg_match(':(\d+)M:i',$str,$toks)) return $toks[1]*1024;
    if (preg_match(':(\d+)K:i',$str,$toks)) return $toks[1]*1;
    return intval($str); // default is kb
}


function output_login_gui(&$my_cfg)
{
?>
<form action="<?=$my_cfg['postcot_url']?>" method="post" class="formgui">
<table class="tblgui">
<tr>
    <th colspan="2"><?=abc('login')?></th>
</tr>
<tr>
    <td><?=abc('email')?></td>
    <td><input type="text" name="user_email" value="<?=htmlspecialchars(@$_REQUEST['user_email'])?>" /></td>
</tr>
<tr>
    <td><?=abc('password')?></td>
    <td><input type="password" name="user_password" value="" /></td>
</tr>
<tr>
    <td></td>
    <td><button type="submit" name="btn_login" value="btn_login"><?=abc('Enter')?></button></td>
</tr>
</table>
</form>
<?
    return '';
}
function submit_login_gui(&$my_cfg)
{
    $mlist=array();
    if ($user_email=strtolower(trim(@$_REQUEST['user_email'])))
    {
	$rs=selectPrepared('select * from postcot_users where pc_address=?',array($user_email));
	while($urow=$rs->fetch())
	{
	    if ($urow['pc_type']!='L' && $urow['pc_type']!='E') // off
	    {
	    	$mlist[]=abc('access denied');
	    	return $mlist;
	    }
	    if (strcasecmp($urow['pc_password'],md5($_REQUEST['user_password'])))
	    {
	    	$mlist[]=abc('invalid password');
	    	return $mlist;
	    }
	    $_SESSION['postcot_user_address']=$urow['pc_address'];
	    $_SESSION['postcot_user_password']=$_REQUEST['user_password']; // x sieve
	    return $mlist;
	}
    }
    $mlist[]=abc('login failure');
    return $mlist;
}

function submit_logout_gui(&$my_cfg)
{
    unset($_SESSION['postcot_user_address']);
}


function output_user_welcome(&$my_cfg)
{
    $urow=select_my_row($my_cfg);

?>
<form action="<?=$my_cfg['postcot_url']?>" method="post" class="formgui">
<table class="tblgui">
<tr>
    <th><?=abc('welcome')?> <?=$my_cfg['pc_address']?></th>
</tr>

<tr>
    <td><a href="<?=$my_cfg['postcot_url']?>?btn_chgpasswd=btn_chgpasswd"><?=abc('change password')?></a></td>
</tr>
<tr>
    <td>
    <a href="<?=$my_cfg['postcot_url']?>?btn_forwarding=btn_forwarding"><?=abc('email forwarding')?> (<?=$urow['pc_alias_csv']?abc('on'):abc('off')?>)</a>
    </td>
</tr>
<? if(POSTCOT_MANAGESIEVE_YN=='Y') { ?>
<tr>
    <td><a href="<?=$my_cfg['postcot_url']?>?btn_vacation=btn_vacation"><?=abc('vacation message')?></a></td>
</tr>
<? if ($my_cfg['ulev']=='super') { ?>
<tr>
    <td><a href="<?=$my_cfg['postcot_url']?>?btn_sieve=btn_sieve"><?=abc('sieve script')?></a></td>
</tr>
<? } ?>
<? } ?>

<? if ($urow['pc_diskusage_kb']||$urow['pc_diskquota_kb']) { ?>
<tr>
    <td>
    <?=abc('disk quota')?> <?=quota_kb_str($urow['pc_diskusage_kb'])?> / <?=quota_kb_str($urow['pc_diskquota_kb'])?>
    </td>
</tr>
<? } ?>


<? if ($my_cfg['ulev']=='super') { ?>
<tr>
    <td style="border-top: 1px solid #ccc;"><a href="<?=$my_cfg['postcot_url']?>?btn_help=btn_help"><?=abc('postcot install guide')?></a></td>
</tr>
<? } ?>
<tr>
    <td><a href="<?=$my_cfg['postcot_url']?>?btn_credits=btn_credits"><?=abc('credits')?></a></td>
</tr>
</table>
<form>
<?
    return '';
}



function output_change_password(&$my_cfg)
{
?>
<form action="<?=$my_cfg['postcot_url']?>" method="post" class="formgui">
<table class="tblgui">
<tr>
    <th colspan="2"><?=abc('change password')?></th>
</tr>
<tr>
    <td><?=abc('password')?></td>
    <td><input type="password" name="user_password1" value="" /></td>
</tr>
<tr>
    <td><?=abc('repeat password')?></td>
    <td><input type="password" name="user_password2" value="" /></td>
</tr>
<tr>
    <td></td>
    <td>
	<button type="submit" name="btn_chgpasswd_ok" value="btn_chgpasswd_ok"><?=abc('Change')?></button>
	&nbsp;
	<button type="submit" name="btn_home" value="btn_home"><?=abc('Cancel')?></button>
    </td>
</tr>
</table>
</form>
<?
    return '';
}
function submit_change_password(&$my_cfg)
{
    $mlist=array();
    if (!$_REQUEST['user_password1']) $mlist[]=abc('FAIL invalid password');
    if ($mlist) return $mlist;

    $clear_pass=trim($_REQUEST['user_password1']);
    if ($clear_pass!=$_REQUEST['user_password2']) $mlist[]=abc('FAIL passwords are not the same');
    if ($mlist) return $mlist;

    if ($msg=validate_password_msg($clear_pass,$my_cfg['pc_address'])) $mlist[]=$msg;
    if ($mlist) return $mlist;

    $rs=selectPrepared('select * from postcot_users where pc_address=?',array($my_cfg['pc_address']));
    while($urow=$rs->fetch())
    {
	$new_pc_password=md5($clear_pass);
	if (strcasecmp($new_pc_password,$urow['pc_password'])==0) $mlist[]=abc('FAIL new password is identical to old password');
	else if (!update_where('update postcot_users set pc_password=?,pc_maddr=?,pc_mtime=current_timestamp where pc_id=?',
	    array($new_pc_password,$my_cfg['pc_address'],$urow['pc_id']))) $mlist[]=abc('FAIL database');
	return $mlist;
    }
    $mlist[]=abc('FAIL user not found');
    return $mlist;
}

function output_forwarding_gui(&$my_cfg)
{
    $urow=select_my_row($my_cfg);

    if ($urow['pc_alias_csv']) $alias_list=preg_split(':\s*,\s*:',$urow['pc_alias_csv'],-1,PREG_SPLIT_NO_EMPTY);
    else $alias_list=array();

?>
<form action="<?=$my_cfg['postcot_url']?>" method="post" class="formgui">
<table class="tblgui">
<tr>
    <th colspan="2">
	<?=sprintf(abc('forward email for %s to'),$my_cfg['pc_address'])?>:<br/>
    </th>
</tr>
<tr>
    <td><?=abc('email list')?></td>
    <td>

	<textarea name="pc_alias_csv" cols="39" rows="10"><?=htmlspecialchars(implode("\n",$alias_list))?></textarea>
	<div><?=abc('insert one or more email addresses, one per line')?></div>
    </td>
</tr>
<tr>
    <td></td>
    <td>
	<button type="submit" name="btn_forwarding_y" value="btn_forwarding_y"><?=abc('Enable')?></button>
	&nbsp;
	<button type="submit" name="btn_forwarding_n" value="btn_forwarding_n"><?=abc('Disable')?></button>
	&nbsp;
	<button type="submit" name="btn_home" value="btn_home"><?=abc('Cancel')?></button>
    </td>
</tr>
</table>
</form>
<?
    return '';
}
function submit_forwarding(&$my_cfg)
{
    $mlist=array();
    $new_pc_alias_csv=null;

    if (isset($_REQUEST['btn_forwarding_y']))
    {
	$alist=preg_split(':\s*\n\s*:',trim($_REQUEST['pc_alias_csv']),-1,PREG_SPLIT_NO_EMPTY);
	foreach($alist as $aa)
	{
	    if (!email_address_check($aa)) $mlist[]=abc('BAD email address').' '.$aa;
	}
	if (!$alist) $mlist[]=abc('BAD email list');
	if ($mlist) return $mlist;
	usort($alist,'strcasecmp');
	$new_pc_alias_csv=strtolower(implode(',',$alist));

    }
    if (!update_where('update postcot_users set pc_alias_csv=?,pc_maddr=?,pc_mtime=current_timestamp where pc_address=?',
    	array($new_pc_alias_csv,$my_cfg['pc_address'],$my_cfg['pc_address'])))
    	$mlist[]=abc('FAIL database');
    return $mlist;
}


function output_credits_gui(&$my_cfg)
{
?>
<form action="<?=$my_cfg['postcot_url']?>" method="post" class="formgui">
<table class="tblgui">
<tr>
    <th colspan="2">
	<?=abc('credits')?><br/>
    </th>
</tr>
<tr>
    <td colspan="2">
    <?=POSTCOT_VERSION?> by
    <a href="http://www.marcomoser.it" target="_blank">Marco Moser</a>
    </td>
</tr>
<tr>
    <td colspan="2">
    <?=abc('Licence')?>:<br/>
    <textarea cols="70" rows="8">
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

The GNU General Public License can be found at
http://www.gnu.org/copyleft/gpl.html.
    </textarea>
    </td>
</tr>
<tr>
    <td colspan="2">
	<button type="submit" name="btn_home" value="btn_home"><?=abc('Cancel')?></button>
    </td>
</tr>
</table>
</form>
<?
    return '';
}


function output_sieve_gui(&$my_cfg)
{
    $merr=managesieve_get_and_set('download',$script_buf);
    if ($merr)
    {
    	print '<div class="divmsg">'.$merr.'</div>';
    	return;
    }

    if (!@$sieve_script=$_REQUEST['sieve_script']) $sieve_script=$script_buf;

?>
<form action="<?=$my_cfg['postcot_url']?>" method="post" class="formgui">
<table class="tblgui">
<tr>
    <th colspan="2">
	<?=abc('sieve script')?><br/>
    </th>
</tr>
<tr>
    <td colspan="2">
	<textarea name="sieve_script" cols="80" rows="20"><?=htmlspecialchars($sieve_script)?></textarea>
    </td>
</tr>
<tr>
    <td></td>
    <td>
	<button type="submit" name="btn_sieve_ok" value="btn_sieve_ok"><?=abc('Apply')?></button>
	&nbsp;
	<button type="submit" name="btn_home" value="btn_home"><?=abc('Cancel')?></button>
    </td>
</tr>
</table>
</form>
<?
    return '';
}
function submit_sieve(&$my_cfg)
{
    $mlist=array();

    $sieve_script=$_REQUEST['sieve_script'];
    $merr=managesieve_get_and_set('upload',$sieve_script);
    if ($merr)
    {
    	$mlist[]=$merr;
    	return $mlist;
    }
    return $mlist;
}



function output_vacation_gui(&$my_cfg)
{
    $merr=managesieve_get_and_set('download',$script_buf);
    if ($merr)
    {
    	print '<div class="divmsg">'.$merr.'</div>';
    	return;
    }

    $vacation_message='';
    $vacation_days=7;
    $vacation_yn='n';
    $vacation_myaddr_csv='';

/*
# rule:[postcotvacation]
if true
{
	vacation :days 2 text:
sono al mare!
.
;
}
*/

    $p1=strpos($script_buf,'# rule:[postcotvacation]');
    if ($p1!==false)
    {
    	$p2=strpos($script_buf,'# rule:',$p1+24);
    	if ($p2>0) $vac_script=substr($script_buf,$p1,$p2);
    	else $vac_script=substr($script_buf,$p1);
    	$vac_script=trim($vac_script);
    	if (preg_match('/\nif true/ius',$vac_script)) $vacation_yn='y'; // dirty simple
    	if (preg_match('/:days (\d+)/ius',$vac_script,$toks)) $vacation_days=intval($toks[1]);
    	//:addresses ["me@you.it","you@me.it"]
    	if (preg_match('/:addresses \[(.*)\]/ius',$vac_script,$toks))
    	{
    	    $vacation_myaddr_csv=trim($toks[1]);
    	    $vacation_myaddr_csv=preg_replace(':":',' ',$vacation_myaddr_csv);
    	}
    	if (preg_match('/text:(.*)\n[.]/ius',$vac_script,$toks)) $vacation_message=trim($toks[1]);
    }

?>
<form action="<?=$my_cfg['postcot_url']?>" method="post" class="formgui">
<table class="tblgui">
<tr>
    <th colspan="2">
	<?=abc('vacation message')?><br/>
    </th>
</tr>
<tr>
    <td><?=abc('status')?></td>
    <td>
	<label><input type="radio" name="vacation_yn" value="y" <?=$vacation_yn=='y'?'checked="checked"':''?> /><?=abc('enable')?></label>
	<label><input type="radio" name="vacation_yn" value="n" <?=$vacation_yn!='y'?'checked="checked"':''?> /><?=abc('disable')?></label>
    </td>
</tr>
<tr>
    <td><?=abc('mail message')?></td>
    <td>
	<textarea name="vacation_message" cols="39" rows="10"><?=htmlspecialchars($vacation_message)?></textarea>
    </td>
</tr>
<tr>
    <td><?=abc('avoid addresses')?></td>
    <td>
	<input type="text" name="vacation_myaddr_csv" value="<?=htmlspecialchars($vacation_myaddr_csv)?>" />
	<div><?=abc('additional e-mail addresse(s) (comma-separated)')?></div>
    </td>
</tr>
<tr>
    <td><?=abc('repeat')?></td>
    <td>
	<input type="text" name="vacation_days" value="<?=htmlspecialchars($vacation_days)?>" />
	<div><?=abc('how often send messages to the same sender (in days)')?></div>
    </td>
</tr>
<tr>
    <td></td>
    <td>
	<button type="submit" name="btn_vacation_ok" value="btn_vacation_ok"><?=abc('Apply')?></button>
	&nbsp;
	<button type="submit" name="btn_home" value="btn_home"><?=abc('Cancel')?></button>
    </td>
</tr>
</table>
</form>
<?
    return '';
}

function submit_vacation(&$my_cfg)
{
    $mlist=array();
    $crlf="\r\n";

    $merr=managesieve_get_and_set('download',$script_buf);
    if ($merr)
    {
    	$mlist[]=$merr;
    	return $mlist;
    }

    // remove previous
    $p1=strpos($script_buf,'# rule:[postcotvacation]');
    if ($p1>0)
    {
    	$p2=strpos($script_buf,'# rule:',$p1+24);
    	if ($p2>0) $script_buf=substr($script_buf,0,$p1).substr($script_buf,$p2);
    	else $script_buf=substr($script_buf,0,$p1);
    }

    $p1=strpos($script_buf,'"vacation"');
    if ($p1===false||$p1>40) $script_buf='require "vacation";'.$crlf.$script_buf;

    // append vacation
    $vacation_days=intval($_REQUEST['vacation_days']);
    $vacation_message=trim($_REQUEST['vacation_message']); //todo,bah avoid ^.$
    $vacation_myaddr_csv=trim($_REQUEST['vacation_myaddr_csv']);
    if ($vacation_myaddr_csv)
    {
    	$alist=array();
    	foreach(preg_split('/\s*,\s*/',$vacation_myaddr_csv) as $aa) $alist[]=sprintf('"%s"',$aa);
    	$vacation_myaddr_csv=':addresses ['.implode(',',$alist).']';
    }

    $script_buf.=$crlf;
    $script_buf.='# rule:[postcotvacation]'.$crlf;
    if ($_REQUEST['vacation_yn']=='y') $script_buf.='if true'.$crlf;
    else $script_buf.='if false # true'.$crlf;
    $script_buf.='{'.$crlf;
    $script_buf.=sprintf('        vacation :days %d '.$vacation_myaddr_csv.' text:'.$crlf.'%s'.$crlf.'.'.$crlf.';'.$crlf,$vacation_days,$vacation_message);
    $script_buf.='}'.$crlf;

    $merr=managesieve_get_and_set('upload',$script_buf);
    if ($merr)
    {
    	$mlist[]=$merr;
    	return $mlist;
    }

    return $mlist;
}

/**
* basic managesieve implementation to use dovecot
* @param $op [download] get script [set] set script
* @param $script_buf i/o
* @return null xor error message
*/
function managesieve_get_and_set($op,&$script_buf)
{
    //to dev
    if (false)
    {
    	$script_buf=<<<EOM
# rule:[postcotvacation]
if true
{
        vacation :days 7  text:
sono in ferie dal 1 al 31

tanti auguri
.
;
}
EOM;

    	return null;
    }

    $crlf="\r\n";
    $fp = @fsockopen(POSTCOT_MANAGESIEVE_HOST,POSTCOT_MANAGESIEVE_PORT,$errno,$errstr);
    if (!$fp)
    {
    	return abc('FAIL connect to managesieve').sprintf(' %s:%d [%s] %s',POSTCOT_MANAGESIEVE_HOST,POSTCOT_MANAGESIEVE_PORT,$errno,$errstr);
    }

    /////////////////////////////
    // get capabilities

    $clist=array();
    $has_vacation=false;
    $has_plain=false;
    while($str=fgets($fp,1024))
    {
    	if (preg_match(':^(OK|NO) :',$str)) break;
    	if (preg_match(':\bSIEVE\b.*\bvacation\b:i',$str)) $has_vacation=true;
    	if (preg_match(':\bPLAIN\b:i',$str)) $has_plain=true;
    	$clist[]=$str;
    }
    //print_r($clist);
    if (!$has_vacation)
    {
    	fclose($fp);
    	return abc('FAIL managesieve vacation support');
    }
    if (!$has_vacation)
    {
    	fclose($fp);
    	return abc('FAIL managesieve authentication (postcot limit)');;
    }

    /////////////////////////////
    // auth

    $cmd=sprintf('AUTHENTICATE "PLAIN" "%s"'.$crlf,base64_encode("\0{$_SESSION['postcot_user_address']}\0{$_SESSION['postcot_user_password']}"));
    if (!fwrite($fp,$cmd))
    {
    	fclose($fp);
    	return abc('FAIL managesieve cmd '.$cmd);
    }
    while($str=fgets($fp,1024))
    {
    	if (preg_match(':^(NO) (.*):',$str,$toks))
    	{
    	    fclose($fp);
    	    return abc('FAIL managesieve login').' '.$toks[2];
    	}
    	if (preg_match(':^(OK|NO) :',$str)) break;
    }

    /////////////////////////////
    // scripts

    $cmd="LISTSCRIPTS".$crlf;
    if (!fwrite($fp,$cmd))
    {
    	fclose($fp);
    	return abc('FAIL managesieve cmd '.$cmd);
    }

    $slist=array();
    $active_script='';
    while($str=fgets($fp,1024))
    {
    	if (preg_match(':"(.*?)" ACTIVE:',$str,$toks)) $active_script=$toks[1];
    	if (preg_match(':^(OK|NO) :',$str)) break;
    	$slist[]=$str;
    }
    //print $active_script;
    //print_r($slist);


    /////////////////////////////
    // download script

    if ($op=='download')
    {
	$script_buf='';
	if ($active_script)
	{
	    $cmd=sprintf('GETSCRIPT "%s"'.$crlf,$active_script);
	    if (!fwrite($fp,$cmd))
	    {
		fclose($fp);
		return abc('FAIL managesieve cmd '.$cmd);
	    }
	    $nn=-1;
	    while($str=fgets($fp,1024))
	    {
		if ($nn==-1 && preg_match(':{(\d+)}:',$str,$toks))
		{
		    $nn=intval($toks[1]);
		    $script_buf=fread($fp,$nn);
		    continue;
		}
		if (preg_match(':^(OK|NO) :',$str)) break;
	    }
	}
    }

    /////////////////////////////
    // upload script

    if ($op=='upload')
    {
    	if (!$active_script) $active_script='postcotfilter';

	$cmd=sprintf('PUTSCRIPT "%s" {%d+}'.$crlf.$script_buf.$crlf,$active_script,strlen($script_buf)); //funziona anche con utf
	if (!fwrite($fp,$cmd))
	{
	    fclose($fp);
	    return abc('FAIL managesieve cmd '.$cmd);
	}
	while($str=fgets($fp,1024))
	{
	    if (preg_match(':^(OK|NO) (.*):',$str,$toks))
	    {
	    	if ($toks[1]=='NO')
	    	{
		    if (preg_match(':^NO {(\d+)}:',$str,$toks))
		    {
			$nn=intval($toks[1]);
			$str=fread($fp,$nn);
		    }
	    	    fclose($fp);
	    	    return abc('FAIL managesieve writing script').' '.$str;
		}
	    	break;
	    }
	}
	$cmd=sprintf('SETACTIVE "%s"'.$crlf,$active_script);
	if (!fwrite($fp,$cmd))
	{
	    fclose($fp);
	    return abc('FAIL managesieve cmd '.$cmd);
	}
	$isok=false;
	while($str=fgets($fp,1024))
	{
	    if (preg_match(':^(OK) :',$str)) $isok=true;
	    if (preg_match(':^(OK|NO) :',$str)) break;
	}
	if (!$isok)
	{
	    fclose($fp);
	    return abc('FAIL managesieve activating script');
	}
    }


    /////////////////////////////
    // quit

    $cmd=sprintf('LOGOUT'.$crlf);
    if (!fwrite($fp,$cmd)); //error
    fclose($fp);
    return null;
}


function email_address_check($email)
{
    if (!$email) return false;
    if (preg_match('/[^\w@._-]/',$email)) return false;
    $toks=preg_split(':@:',$email,-1,PREG_SPLIT_NO_EMPTY);
    if (count($toks)!=2) return false;
    if (!preg_match('/\w@\w./',$email)) return false;
    return true;
}


//2012-11-08 10:58:18.513234
function timestamp_today($ts)
{
    $toks=preg_split(':\D:',$ts,-1,PREG_SPLIT_NO_EMPTY);
    if (count($toks)<6) return $ts;
    if ($toks[2]==date('d') && $toks[1]==date('m')) return sprintf('%d:%02d',$toks[3],$toks[4]);
    return sprintf('%d/%02d/%d',$toks[2],$toks[1],$toks[0]);
}

function abc($msg)
{
    global $ABC_DIC;
    if (isset($ABC_DIC) && isset($ABC_DIC[$msg])) return $ABC_DIC[$msg];
    return $msg;
}





////////////////////////////////////////////////////////////////////////////////


function output_postcot_help(&$my_cfg)
{
    $POSTCOT_VERSION=POSTCOT_VERSION;
    print <<<EOH
<div style="padding: 20px 0px;">
<p>Postcot manages an email-address database for a generic email server based on virtual users</p>
<p>It requires:<br/>
- postgresql or mysql database<br/>
- postfix smtp server<br/>
- dovecot imap/pop3 server, best with dovecot with LDA<br/>
- php5 with pdo<br/>
</p>
<p>For installation guide, go to site <a href="http://www.marcomoser.it/postcot">http://www.marcomoser.it/postcot</a></p>
<p></p>
<p>$POSTCOT_VERSION by <a href="http://www.marcomoser.it" target="_blank">Marco Moser</a></p>
</div>
EOH;
}


// @copyright    Copyright (c) 2015, Marco Moser
// @author       Marco Moser <marco@marcomoser.it>

